###########################################################
#  Spago4Q - The Business Intelligence Free Platform
#
#  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.
#
#  Spago4Q is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#
#  Spago4Q is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
###########################################################

###########################################################
# getEntities.pl                                          #
# ======================================================= #
# Mette a disposizione un socket su cui viene passato un  #
# xml che descrive entit, attributi ed eventuali filtri  #
# per una estrazione da CQ                                #
###########################################################


use strict;
use XML::Simple;
use Data::Dumper;
use CQPerlExt;
use utf8;
# Impostare Write=On per scrivere su exitFile
my $Write = "On";
my $exitFile = "CQOutput_".&GetCurrentDate().".xml";


my $completeCMD = $ARGV[0]; 
#print "CMD: <$completeCMD>\n";
# controllo la struttura di input
$completeCMD =~ s/\s*$//;
chomp($completeCMD);
if(not $completeCMD =~ /^<.*?>/ or not $completeCMD =~ /<\/.*?>$/){
	#print $client "ERRORE sintassi: <$cmd> non  un xml!";
	exit 100;
}
# Lancio l'estrazione
my $output = &getEntity($completeCMD);
#print $output;
print $exitFile;
exit 0;

################################
# getEntity                    #
# ============================ #
# Estrae informazioni da CQ in #
# base ad una struttura xml in #
# input                        #
################################

sub getEntity{
	my $configFile = $_[0];
	#parametri di connessione a CQ
	my $confData = "config.xml";
	my $conf = &readConfig($confData);
	my $CQconn = $conf->{configuration}->{connection};
	my $CQdb = $conf->{configuration}->{db};
	my $CQuser = $conf->{configuration}->{user};
	my $CQpwd = $conf->{configuration}->{psw};
	my $exitData = "VUOTO";
	if($CQpwd =~ /HASH/){
		$CQpwd = "";
	}
	# recupero struttura XML
	my $xml = &readConfig($configFile);
	# Raccolgo info entit
	my $entityRoot = $xml->{entities}->{entity};
	if (defined($entityRoot->{name})){
		my @temp = keys %$entityRoot;
		my %newVar;
		foreach my $tmpKey (@temp){
			$newVar{$tmpKey}=$entityRoot->{$tmpKey};
			delete $entityRoot->{$tmpKey};
		}
		$entityRoot->{$newVar{name}}= \%newVar;
		delete $entityRoot->{$newVar{name}}->{name};		
	}
	my @entities = keys %$entityRoot;
	
	# Connessione a ClearQuest
	#print "\nConnessione a ClearQuest...";
	my $Session = CQPerlExt::CQSession_Build();
	last unless $Session;
	if ($Session->UserLogon($CQuser, $CQpwd, $CQdb, $CQconn)) {
        #print " FALLITA!>\n";
        last;
	}
	#print " effettuata con successo\n";

	my $workspace = $Session->GetWorkSpace() ;
	#print "Workspace recuperato";

	# --- Test list defined entites ---
	#my $queries = $Session->GetQueryEntityDefNames();

	#my $queries = $workspace->GetAllQueriesList() ;
	#print "Queries List recuperato";
	#foreach my $query (@$queries){
	#	print $query ;
	#	print "\n" ;
	#}
	#return "fine" ;
	# --- 
	
	# Esploro entit
	foreach my $entity (@entities){
		# Creazione query
#		my $queryDef = $Session->BuildQuery($entity);
		my $queryDef = $workspace->GetQueryDef($entity);
#
#		my $attrRoot = $entityRoot->{$entity}->{attribute};
#		if (defined($attrRoot->{name})){
#			my @temp = keys %$attrRoot;
#			my %newVar;
#			foreach my $tmpKey (@temp){
#				$newVar{$tmpKey}=$attrRoot->{$tmpKey};
#				delete $attrRoot->{$tmpKey};
#			}
#			$attrRoot->{$newVar{name}}= \%newVar;
#			delete $attrRoot->{$newVar{name}}->{name};		
#		}
#		my @attributes = keys %$attrRoot;
#		sort(@attributes);
#		my $filter = $queryDef->BuildFilterOperator($CQPerlExt::CQ_BOOL_OP_AND);
		my @refList;
		my @refType;
#		foreach my $attr (@attributes){
#				if(defined($attrRoot->{$attr}->{reflist})){
#				if($attrRoot->{$attr}->{reflist} eq "yes" or $attrRoot->{$attr}->{reflist} eq "list"){
#					#print "REFERENCE LIST";
#					push(@refList,$attr);
#					push(@refType,$attrRoot->{$attr}->{reflist});
#					next;
#				}
#			}
#			# Creazione campo della query
#			$queryDef->BuildField($attr);
#			my @filters;
#			my $filterRoot = $attrRoot->{$attr}->{filter};
#			if(defined($filterRoot)){
#				# Creazione filtri
#				if($filterRoot =~ /ARRAY/){
#					my @array = @$filterRoot;
#					for(my $i=0; $i<$#array+1; $i++){
#						my $operation = $array[$i]->{operation};
#						my $value = $array[$i]->{value};
#						&SetFilter($filter,$operation,$value,$attr);
#					}
#				} else {
#					my $operation = $filterRoot->{operation};
#					my $value = $filterRoot->{value};
#					&SetFilter($filter,$operation,$value,$attr);
#				}
#			}
#		}
		# Esecuzione Query
		my $result = $Session->BuildResultSet($queryDef);
		$result->EnableRecordCount();
		$result->Execute();
		my $row = $result->GetRecordCount();
		my $cols = $result->GetNumberOfColumns();
		#print "ROW: $row\n";
		# Raccolgo struttura xml di output
		$exitData = " <entities>\n";
		&WriteFile($exitFile,"<entities>\n",">");
		while($result->MoveNext() eq $CQPerlExt::CQ_SUCCESS){
			&WriteFile($exitFile,"\t<entity>\n");
			$exitData=$exitData."\t<entity>\n";
			my $id;
			for(my $k=0; $k<$cols; $k++){
				my $attr = $result->GetColumnLabel($k+1);
				my $value = $result->GetColumnValue($k+1);
                                utf8::encode($value);
				if ($attr eq "id"){
					$id = $value;
				}
				$exitData = $exitData."\t\t<".$attr."><![CDATA[".$value."]]></".$attr.">\n";
				&WriteFile($exitFile,"\t\t<".$attr."><![CDATA[".$value."]]></".$attr.">\n");
			}
			foreach my $elem (@refList){
				my $entityObj = $Session->GetEntity($entity,$id);
				my $lista = $entityObj->GetFieldValue($elem)->GetValueAsList();
				# Verifico se estrarre numero o lista
				my $type = shift(@refType);
				my $value;
				if ($type eq "yes"){
					$value = scalar(@$lista);
				} else {
					$value = "";
					foreach my $listElem (@$lista){
						$value=$value.",".$listElem;
					}
					$value =~ s/^,//;
				}
				$exitData = $exitData."\t\t<".$elem.">".$value."></".$elem.">\n";
				&WriteFile($exitFile,"\t\t<".$elem.">".$value."></".$elem.">\n");
			}
			$exitData=$exitData."\t</entity>\n";
			&WriteFile($exitFile,"\t</entity>\n");
		}
		$exitData=$exitData."</entities>\n";
		&WriteFile($exitFile,"</entities>\n");
	}
	return $exitData;
}

#############################################################
# readConfig                                                #
# read a configuration xml file return a reference to an    #
# hash structure                                            #
#===========================================================#
# input:                                                    #
#    -configFile: absolute path to configuration file       #
# output:                                                   #
#    -xmlDoc: referenct to xml structure                    #
#############################################################
sub readConfig(){
	my ($configFile)=@_;
	my $xmlInStream = XML::Simple->new(keeproot => 1);
  	my $xmlDoc = $xmlInStream->XMLin($configFile);
  	return $xmlDoc;
}


#############################################################
# WriteFile                                                 #
# writing on a file                                         #
#===========================================================#
# input -file : name of the file on which to write (absolute#
#               path included)                              #
#	      -string: string to be written                     #
#       -mode: writing mode, by default is "append"         #
#############################################################
sub WriteFile{
	my $file = $_[0];
	my $string = $_[1];
	my $mode = $_[2];
	if ($Write eq "On"){
		if (!defined($mode)){ $mode =">>";}
		open(OUT,$mode.$file);
		print OUT $string;
		#print $string;
		close(OUT);
	}
}
################
# SetFilter
sub SetFilter{
	my $filterObj = $_[0];
	my $op = $_[1];
	my $act = $_[2];
	my $att = $_[3];
	
	my @values;
	if($op =~ /BETWEEN/ or $op =~ /IN$/){
		@values=split(",",$act);
	} else {
		push(@values,$act);
	}
	
	if ($op eq "EQ"){
		$filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_EQ,\@values);
	}
	elsif ($op eq "NEQ"){
		$filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_NEQ,\@values);
	}
	elsif ($op eq "LT"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_LT,\@values);
        }
	elsif ($op eq "LTE"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_LTE,\@values);
        }
	elsif ($op eq "GT"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_GT,\@values);
        }
	elsif ($op eq "GTE"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_GTE,\@values);
        }
	elsif ($op eq "LIKE"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_LIKE,\@values);
        }
	elsif ($op eq "NOT_LIKE"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_NOT_LIKE,\@values);
        }
	elsif ($op eq "BETWEEN"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_BETWEEN,\@values);
        }
	elsif ($op eq "NOT_BETWEEN"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_NOT_BETWEEN,\@values);
        }
	elsif ($op eq "IS_NULL"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_IS_NULL,\@values);
        }
	elsif ($op eq "IS_NOT_NULL"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_IS_NOT_NULL,\@values);
        }
	elsif ($op eq "IN"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_IN,\@values);
        }
	elsif ($op eq "NOT_IN"){
                $filterObj->BuildFilter($att,$CQPerlExt::CQ_COMP_OP_NOT_IN,\@values);
        }
	else {
		&WriteFile($exitFile,"ERRORE: operazione <$op> non prevista!\n");
		exit 1;
	}
}


sub GetCurrentDate() {
    my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $time) = localtime();
    return sprintf("%4d%2.2d%2.2d%2.2d%2.2d%2.2d", $year + 1900, $mon + 1, $mday,  $hour, $min, $sec);
}
