/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors.clearquest;

import java.util.ArrayList;
import java.util.List;

public class InputSourceBean {

	private String entryName;
	private List<AttributeElement> elements;
	protected static final String ATTRIBUTE_NAME = "name";
	

	public InputSourceBean(final String entryName) {
		setEntryName(entryName);
		elements = new ArrayList<AttributeElement>();
	}

	private String getEntryName() {
		return entryName;
	}

	private void setEntryName(String entryName) {
		this.entryName = entryName;
	}

	public void setStandardElement(String value) {
		AttributeElement element = new AttributeElement();
		element.setAttribute(ATTRIBUTE_NAME, value);
		elements.add(element);
	}
	
	public void setElement(AttributeElement element){
		elements.add(element);
	}

	@Override
	public String toString() {
		String toReturn = "<entities><entity name=\"" + getEntryName() + "\">";
		for (AttributeElement element : elements) {
			toReturn += element.toString();
		}
		toReturn += "</entity></entities>\n";
		return toReturn;
	}

}
